/// <reference types="express-serve-static-core" />
import 'reflect-metadata';
import { RequestHandler } from 'express-serve-static-core';
/**
 * Controller decorator; decorates a class to be a rest api controller. A controller registers itself to an
 * expressJS router when "registerControllers" is called.
 *
 * @param {string} [routePrefix] - Prefix for the whole controller. This path is added to all routes.
 * @param {RequestHandler[]} [middlewares] - Middleware functions for the controller to be executed before the routing functions.
 * @returns {(Function) => void} - Decorator for the controller class.
 */
export declare function Controller(routePrefix?: string, ...middlewares: RequestHandler[]): (controller: any) => void;
