/// <reference types="express" />
import 'reflect-metadata';
import { ControllerRegistration } from '../models/ControllerRegistration';
import { ControllerLoaderOptions, Registrar } from './Registrar';
import { RouteHandler } from './RouteHandler';
import { Router } from 'express';
/**
 * Default implementation of the registrar class.
 * Handles the registration of controllers.
 *
 * @class
 */
export declare class DefaultRegistrar implements Registrar {
    private routeHandler;
    private controllers;
    constructor(routeHandler: RouteHandler);
    registerControllersFromFolder({folderPath, root, recursive, matchRegExp}: ControllerLoaderOptions, baseUrl?: string, router?: Router): Promise<Router>;
    registerControllers(baseUrl?: string, router?: Router): Router;
    addController(controller: ControllerRegistration): void;
    resetControllerRegistrations(): void;
}
