/// <reference types="express-serve-static-core" />
import { RouteMethod } from '../routes/RouteDecorators';
import { RequestHandler } from 'express-serve-static-core';
/**
 * Class for the registered routes. Contains all information for the "registerControllers" method to register the given routes.
 *
 * @class
 */
export declare class RouteRegistration {
    path: string;
    method: RouteMethod;
    descriptor: PropertyDescriptor;
    propertyKey: string;
    middlewares: RequestHandler[];
    constructor(path: string, method: RouteMethod, descriptor: PropertyDescriptor, propertyKey: string, middlewares?: RequestHandler[]);
}
